/*
 * ʰץץեѥɥ饤
 * main.c: ɥ饤
 *
 * (C)Copyright 2009, Yashiro Takeshi <yashiromann@nifty.com>
 */

#define	DEBUG_MODULE "(vf)"
#include <tk/tkernel.h>
#include <tk/util.h>
#include <tk/dbgspt.h>
#include <device/sdrvif.h>
#include <device/util.h>
#include <util/debug.h>
#include <string.h>

#include "vf.h"

#define vf_cyc_freq 10

static ID  vf_mbf;
static SDI vf_sdi;

static W vf_cycid = -1;
static volatile BOOL vf_running = FALSE;
static W vf_tid[VF_MAX_TSKID];
static W vf_ntid = 0;
static W vf_sample_tid = -1;
static UW vf_prev_stime[VF_MAX_TSKID];
static UW vf_prev_utime[VF_MAX_TSKID];

/* defined in cpu_xxx.c */
extern VP get_instruction_pointer(W tid);
#if VF_ENABLE_CUMULATIVE
#endif

/* defined in db.c */
extern VFTimes* vf_get_entry(void* pc, BOOL generate);
extern int vf_get_next(VFEntry* entry, int n, void** ppc);
extern void vf_clear();
extern VFTimes vf_total;
extern VFTimes* vf_data;

static VP vf_pc = NULL;


static void vf_sampling_task(INT stacd, VP exinf)
{
    VFTimes* entry;
    ER er;
    T_ITSK pk_itsk;
    void* pc;
    int i;
    UW delta_utime;
    UW delta_stime;
    UW delta_rtime;

    for (;;) {
        er = tk_slp_tsk(TMO_FEVR);

        if (!vf_running) {
            tk_can_wup(TSK_SELF);
            continue;
        }

        /*
         * ʲνϳޤƤϤʤΤա
         * (äơܥɥ饤ФȤץ⤤ͥ٤
         *  뤳Ȥɬ)
         */
        for (i = 0; i < vf_ntid; i++) {
            /* CAUTION: ǥ֤ͭѹΤ */
            pc = get_instruction_pointer(vf_tid[i]);

            entry = vf_get_entry(pc, TRUE);

            /* CPU֤κʬ + vf_prev_[su]timeι */
            er = tk_inf_tsk(vf_tid[i], &pk_itsk, FALSE);
            if (er >= 0) {
                if (vf_prev_stime[i] == (UW)-1) {
                    vf_prev_stime[i] = pk_itsk.stime;
                }
                if (vf_prev_utime[i] == (UW)-1) {
                    vf_prev_utime[i] = pk_itsk.utime;
                }
                delta_stime = pk_itsk.stime - vf_prev_stime[i];
                delta_utime = pk_itsk.utime - vf_prev_utime[i];
                vf_prev_stime[i] = pk_itsk.stime;
                vf_prev_utime[i] = pk_itsk.utime;
            }
            if (er < 0) {
                delta_stime = 0;
                delta_utime = 0;
                vf_prev_stime[i] = (UW)-1;
                vf_prev_utime[i] = (UW)-1;
            }

            delta_rtime = vf_cyc_freq;

            /* ջ֤û */
            entry->self_stime += delta_stime;
            entry->self_utime += delta_utime;
            entry->self_rtime += delta_rtime;

#if VF_ENABLE_CUMULATIVE
            /* ѻ֤û */
            ; /* TODO: ȥå unwind ơȤɤ߽Ф */
#endif
        }
    }

    /* Never reached */
    tk_exd_tsk();
}


static void vf_cychdr()
{
    if (vf_running) {
        tk_wup_tsk(vf_sample_tid);
    }
}


static W vf_set_enable(BOOL enable)
{
    T_ITSK pk_itsk;
    ER er = 0;
    int i;

    if (vf_running == enable) {
        return 0;
    }

    if (enable) {
        for (i = 0; i < vf_ntid; i++) {
            er = tk_inf_tsk(vf_tid[i], &pk_itsk, FALSE);
            if (er >= 0) {
                vf_prev_stime[i] = pk_itsk.stime;
                vf_prev_utime[i] = pk_itsk.utime;
            }
            else {
                vf_prev_stime[i] = (UW)-1;
                vf_prev_utime[i] = (UW)-1;
            }
        }
        er = tk_sta_cyc(vf_cycid);
        if (er < 0) {
            return er;
        }
        vf_running = TRUE;
    }
    else {
        er = tk_stp_cyc(vf_cycid);
        if (er < 0) {
            return er;
        }
        vf_running = FALSE;
    }
    return 0;
}


/*
  ѥ᡼Υå
  = E_OK : OK (size == 0)
  > E_OK : OK (size > 0)
  < E_OK : 顼
*/
static ER CheckPar(W size, W dsz)
{
    if (size < 0 || (size > 0 && size < dsz)) return E_PAR;
    return size ? (E_OK + 1) : E_OK;
}


static INT vf_rwfn(BOOL rd, ID devid, INT start, INT size, VP buf, SDI sdi)
{
    INT	er = 0;
    W dsz;
    void* p;

    switch (start) {

    case DN_VFENABLE:
        er = CheckPar(size, dsz = sizeof(W));
        if (er < E_OK) {
            break;
        }
        if (rd) {
            *(W*)buf = vf_running;
        }
        else {
            if (vf_ntid <= 0 && *(W*)buf) {
                er = E_OBJ;
                break;
            }
            er = vf_set_enable(*(W*)buf ? TRUE : FALSE);
        }
        break;

    case DN_VFCLEAR:
        if (rd) {
            er = E_PAR;
            break;
        }
        er = CheckPar(size, dsz = sizeof(W));
        if (er < E_OK) {
            break;
        }
        if (*(W*)buf) {
            vf_clear();
            er = E_OK;
        }
        break;

    case DN_VFTASK:
        if (size < 0 || size > VF_MAX_TSKID * sizeof(W)
            || (size % sizeof(W)) != 0) {
            er = E_PAR;
            break;
        }
        if (rd) {
            dsz = size;
            if (dsz > vf_ntid * sizeof(W)) {
                dsz = vf_ntid * sizeof(W);
            }
            memcpy(buf, vf_tid, dsz);
            er = E_OK;
        }
        else {
            dsz = size;
            vf_ntid = size / sizeof(W);
            memcpy(vf_tid, buf, size);
            er = E_OK;
        }
        break;

    case DN_VFPC:
        er = CheckPar(size, dsz = sizeof(VP));
        if (er < E_OK) {
            break;
        }
        if (rd) {
            *(W*)buf = (W)vf_pc;
        }
        else {
            vf_pc = (VP)(*(W*)buf);
        }
        break;

    default:
        if (start != 0 || !rd || size <= 0 
            || (size % sizeof(VFEntry)) != 0) {
            er = E_PAR;
            break;
        }
        dsz = vf_get_next((VFEntry*)buf, size / sizeof(VFEntry), &vf_pc)
            * sizeof(VFEntry);
        er = E_OK;
        break;
    }

    if (er >= E_OK) {
        er = dsz;
    }
    else {
        DEBUG_PRINT(("rwData dn:%d err = %d\n", start, er));
    }

    return er;
}


static INT vf_readfn(ID devid, INT start, INT size, VP buf, SDI sdi)
{
    return vf_rwfn(TRUE, devid, start, size, buf, sdi);
}


static INT vf_writefn(ID devid, INT start, INT size, VP buf, SDI sdi)
{
    return vf_rwfn(FALSE, devid, start, size, buf, sdi);
}


static W vf_init()
{
    ER er;

    T_CTSK pk_ctsk;
    SetOBJNAME(pk_ctsk.exinf, "vfpd");
    pk_ctsk.tskatr = TA_HLNG|TA_RNG0;
    pk_ctsk.task = vf_sampling_task;
    pk_ctsk.itskpri = 80; /* ץեоݤͥ٤Ǥʤ */

    T_CCYC pk_ccyc;
    SetOBJNAME(pk_ccyc.exinf, "vfpd");
    pk_ccyc.cycatr = TA_HLNG;
    pk_ccyc.cychdr = vf_cychdr;
    pk_ccyc.cyctim = vf_cyc_freq;
    pk_ccyc.cycphs = vf_cyc_freq / 2;

    memset(&vf_total, 0, sizeof(VFTimes));
    vf_data = NULL;

    vf_running = FALSE;
    vf_ntid = 0;

    er = tk_cre_tsk(&pk_ctsk);
    if (er < 0) {
        goto err_ret0;
    }
    vf_sample_tid = er;

    er = tk_sta_tsk(vf_sample_tid, 0);
    if (er < 0) {
        goto err_ret1;
    }

    er = tk_cre_cyc(&pk_ccyc);
    if (er < 0) {
        goto err_ret2;
    }
    vf_cycid = er;

    return 0;

err_ret2:
    tk_ter_tsk(vf_sample_tid);
err_ret1:
    tk_del_tsk(vf_sample_tid);
err_ret0:
    return er;
}


static void vf_finish()
{
    if (vf_cycid >= 0) {
        tk_stp_cyc(vf_cycid);
        tk_del_cyc(vf_cycid);
        vf_cycid = -1;
    }
    vf_running = FALSE;
    if (vf_sample_tid >= 0) {
        tk_ter_tsk(vf_sample_tid);
        tk_del_tsk(vf_sample_tid);
        vf_sample_tid = -1;
    }

    vf_ntid = 0;
    vf_clear();
}


ER main(INT ac, UB *av[])
{
    ER er;
    T_IDEV idev;
    static SDefDev ddev = {
        NULL,           /* exinf */
        VF_DEVNM,       /* devnm */
        0,              /* drvatr */
        0,              /* devatr */
        0,              /* nsub */
        1,              /* blksz */
        NULL,           /* open */
        NULL,           /* close */
        vf_readfn,      /* read */
        vf_writefn,     /* write */
        NULL,
    };    

    /* Terminate request */
    if (ac < 0) {
        vf_finish();
        return E_OK;
    }

    /* Driver initialization */
    er = vf_init();
    if (er < 0) {
        goto err_ret;
    }

    /* Device registration */
    er = SDefDevice(&ddev, &idev, &vf_sdi);
    if (er < 0) {
        goto err_ret;
    }
    vf_mbf = idev.evtmbfid;

    return 0;

err_ret:
    DEBUG_PRINT(("VFProfiler er = %d\n", er));
    return er;
}

